/*
** Copyright (c) Oracle Corporation 2000-2003. All Rights Reserved.
**
** @version $Name:  $ ($Revision: 1.122 $) $Date: 2003/05/15 23:28:54 $
**
**34567890123456789012345678901234567890123456789012345678901234567890123456789
*/


/**
 * Equivalent of targetItem.outerHTML = sourceItem.outerHTML for platforms
 * that don't support outerHTML, but do support innerHTML, or platforms that
 * don't suppoer outerHTML on all elements
 */
function _setOuterHTML(
  targetDocument,
  targetItem,
  sourceItem
  )
{
  var sourceTagName = sourceItem.tagName;

    var i;
    // create the new Target item using a namespace to create this item
    // screws up Mozilla!
   var newTargetItem;
    

    newTargetItem = sourceItem.cloneNode(true); 
   
    // Replace the current child with the new child.
    // We would like replaceChild(), but this causes problems on
    // Mozilla.  For example, in the PPR validation demo, if we use
    // replaceChild(), the validation demo contents disappear!  Using
    // insertBefore() followed by removeChild() seems to work just
    // fine though...
    
    //=-=jmw The cloneNode bug appears whether we do either of these cases.
    // targetItem.parentNode.replaceChild(newTargetItem, targetItem);

    targetItem.parentNode.insertBefore(newTargetItem, targetItem);
    targetItem.parentNode.removeChild(targetItem);


  return targetItem;
}



/**
 *
 *
 *
 * Onload event handler for the partial iframe
 */
function _partialChange(navigationFormName)
{
  alert("jmw in _partialChange. This copies from the iframe to the main frame.");
  


/**************************************************/
// If I comment out this part then I don't have a problem.

 // use source document, since Mozilla claims that
  // the document object no longer exists
  // when we call write and close at the end
  // of this method
  var sourceDocument = document;
  var targetDocument = parent.document;

  for (var i = 0; i < _pprTargets.length; i++)
  {

    var targetID = _pprTargets[i];

    var sourceItem = sourceDocument.getElementById(targetID);

    var targetItem = targetDocument.getElementById(targetID);
    
    if (sourceItem && targetItem)
    {

      _setOuterHTML(targetDocument, targetItem, sourceItem);

    }
  }
  /************************/
   // Check for any scripts that need to be executed
   
   // NOTE THAT IF I MOVE THIS EVAL TO EXECUTE FIRST IN THIS FUNCTION
   // I ALWAYS GET THE ERROR. /**************************** */
  _eval(parent, _getCommentedScript("_pprScripts"));


}




// The partial page response includes a single script element
// which contains all of the code that needs to be executed when
// the partial page changes are applied.  Oddly enough, the code
// is actually commented out to prevent execution within the
// iframe context.  We need to pull the code out from the comment
// braces (/* */) and execute the code in the parent window's
// context.  This function returns the uncommented script code
// that needs to be executed in the parent window.
function _getCommentedScript(id)
{
  var scriptItem = document.getElementById(id);

  if (scriptItem != null)
  {
    var scriptContents = scriptItem.text;

    // Strip off the start/end comments
    var start = 0;
    var end = scriptContents.length - 1;

    while (start < end)
    {
      if (scriptContents.charAt(start) == '*')
        break;

      start++;
    }

    while (end > start)
    {
      if (scriptContents.charAt(end) == '*')
        break;

      end--;
    }

    // Rip out the actual script contents from within the comments
    return scriptContents.substring(start + 1, end);
  }

  return null;
}

// Evaluates the specified code in the target window
function _eval(targetWindow, code)
{
  if (code == null)
    return;

  targetWindow.eval(code);
}




